var youtubequality = {
  
  qualityStrings : new Array("small","medium","large","hd720","hd1080","highres","default"),
  playerType: function(){
  	this.object = null;
	this.timer = -1;
	this.isReady = false;
	this.url = '';
  },
  myPlayers: new Array(),
  myQuality: 'default',
  onLoad: function() {
    // initialization code
	gBrowser.addEventListener("load", youtubequality.onPageLoad, true);
	gBrowser.addEventListener("unload", youtubequality.onPageUnload, false);
    this.initialized = true;
    this.strings = document.getElementById("youtubequality-strings");
	
	
	try{
		youtubequality.myQuality = youtubequality.getStringPref("videoquality");
		
		for(var i=0; i<youtubequality.qualityStrings.length; i++){
			if(youtubequality.qualityStrings[i] == youtubequality.myQuality){
				document.getElementById('yq-set-quality-menu').childNodes[i].setAttribute("checked","true");
				
			}
		}
	}catch(e){
	}
  },
 
  onMenuItemCommand: function(e) {
    
  },
	getBoolPref: function(name){
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.youtubequality.");
	return prefs.getBoolPref(name);
  },
  setBoolPref: function(name, val){
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.youtubequality.");
	prefs.setBoolPref(name, val);
  },
  getStringPref: function(name){
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.youtubequality.");
	return prefs.getCharPref(name);
  },
  setStringPref: function(name, val){
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch("extensions.youtubequality.");
	prefs.setCharPref(name, val);
  },
  
  setQuality: function(menuItem,qt){
  	youtubequality.myQuality = youtubequality.qualityStrings[qt];
	youtubequality.setStringPref("videoquality",youtubequality.qualityStrings[qt]);
	youtubequality.setPlayersQuality(youtubequality.qualityStrings[qt]);
  },
  setPlayersQuality: function(quality){
  	for(var i=0; i<youtubequality.myPlayers.length; i++ ){
		if(youtubequality.myPlayers[i].isReady)
			youtubequality.setPlayerQuality(youtubequality.myPlayers[i].object,quality);
		
	}
	
  },
  setPlayerQuality: function(object,quality){
  		
  		try{
			
			var locPlayerObj = object.wrappedJSObject.content.document.getElementById('movie_player');
			if(locPlayerObj){
					locPlayerObj.setPlaybackQuality(quality);
				}
					
		}catch(e){};
	
	
  }, 
  checkPlayerReady: function(playerTypeObject){
  		var locPlayerObj = playerTypeObject.object.wrappedJSObject.content.document.getElementById('movie_player');
		if(locPlayerObj.getPlayerState() != -1){
				playerTypeObject.isReady = true;
				locPlayerObj.setPlaybackQuality(youtubequality.myQuality);
				
		}
		else{
			playerTypeObject.timer.initWithCallback(
				   function(){youtubequality.checkPlayerReady(playerTypeObject);},
				   500,
				   Components.interfaces.nsITimer.TYPE_ONE_SHOT);
		}
  },
  onPageLoad: function(event) {
	  if (event.originalTarget instanceof HTMLDocument) {
	    var win = event.originalTarget.defaultView;
	    if (win.frameElement) {
	      // Frame within a tab was loaded. win should be the top window of
	      // the frameset. If you don't want do anything when frames/iframes
	      // are loaded in this web page, uncomment the following line:
	     // return;
	      // Find the root document:
	      win = win.top;
	    }
		var myObj = win.wrappedJSObject.content.document.getElementById('movie_player');
		if (myObj != null)
			if (!youtubequality.existsLocation(win.location)){
				event.originalTarget.defaultView.addEventListener("pagehide", function(event){ youtubequality.onPageUnload(event); }, true); 
				var myPlayer = new youtubequality.playerType();
				myPlayer.object = win;
				myPlayer.url = win.location;
				myPlayer.timer = Components.classes["@mozilla.org/timer;1"]
	                    .createInstance(Components.interfaces.nsITimer);
				
				myPlayer.timer.initWithCallback(
					   function(){youtubequality.checkPlayerReady(myPlayer);},
					   500,
					   Components.interfaces.nsITimer.TYPE_ONE_SHOT);
				youtubequality.myPlayers.push(myPlayer);
			}
	  }
	},
	onPageUnload: function(event) {
		if (event.originalTarget instanceof HTMLDocument){
			var win = event.originalTarget.defaultView;
		    if (win.frameElement) {
		      // Frame within a tab was loaded. win should be the top window of
		      // the frameset. If you don't want do anything when frames/iframes
		      // are loaded in this web page, uncomment the following line:
		     // return;
		      // Find the root document:
		      win = win.top;
		    }
	    	youtubequality.existsLocation(win.wrappedJSObject.location,true);
		}
	},
	existsLocation: function(argLocation, removeMe){
		for(var i=0; i<youtubequality.myPlayers.length; i++){
			if(argLocation == youtubequality.myPlayers[i].url){
				if (removeMe)
					youtubequality.myPlayers.splice(i,1);
				return true;	
			}
				
		}
		return false;
	}
};
window.addEventListener("load", function(e) { youtubequality.onLoad(e); }, false);

